<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblSegmentoUsuarioRepository;

final class TblSegmentoUsuarioService
{
    private TblSegmentoUsuarioRepository $TblSegmentoUsuarioRepository;

    public function __construct(TblSegmentoUsuarioRepository $TblSegmentoUsuarioRepository)
    {
        $this->TblSegmentoUsuarioRepository = $TblSegmentoUsuarioRepository;
    }

    public function checkAndGet(int $TblSegmentoUsuarioId): object
    {
        return $this->TblSegmentoUsuarioRepository->checkAndGet($TblSegmentoUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblSegmentoUsuarioRepository->getAll();
    }

    public function getOne(int $TblSegmentoUsuarioId): object
    {
        return $this->checkAndGet($TblSegmentoUsuarioId);
    }

    public function create(array $input): object
    {
        $TblSegmentoUsuario = json_decode((string) json_encode($input), false);

        return $this->TblSegmentoUsuarioRepository->create($TblSegmentoUsuario);
    }

    public function update(array $input, int $TblSegmentoUsuarioId): object
    {
        $TblSegmentoUsuario = $this->checkAndGet($TblSegmentoUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblSegmentoUsuarioRepository->update($TblSegmentoUsuario, $data);
    }

    public function delete(int $TblSegmentoUsuarioId): void
    {
        $this->checkAndGet($TblSegmentoUsuarioId);
        $this->TblSegmentoUsuarioRepository->delete($TblSegmentoUsuarioId);
    }
}
